// OptionsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Sim.h"
#include "OptionsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg dialog


COptionsDlg::COptionsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void COptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsDlg)
	DDX_Control(pDX, IDC_PARITY, m_Combo_Parity);
	DDX_Control(pDX, IDC_STOP_BITS, m_Combo_StopBits);
	DDX_Control(pDX, IDC_BYTE_SIZE, m_Combo_ByteSize);
	DDX_Control(pDX, IDC_BAUD, m_Combo_Baud);
	DDX_Control(pDX, IDC_COM, m_Combo_Com);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionsDlg, CDialog)
	//{{AFX_MSG_MAP(COptionsDlg)
	ON_BN_CLICKED(IDC_APPLY, OnApply)
	ON_BN_CLICKED(IDC_COM_DEFAULTS, OnComDefaults)
	ON_CBN_SELCHANGE(IDC_COM, OnChange)
	ON_CBN_EDITCHANGE(IDC_COM, OnChange)
	ON_CBN_EDITCHANGE(IDC_BAUD, OnChange)
	ON_CBN_SELCHANGE(IDC_BAUD, OnChange)
	ON_CBN_EDITCHANGE(IDC_BYTE_SIZE, OnChange)
	ON_CBN_SELCHANGE(IDC_BYTE_SIZE, OnChange)
	ON_CBN_EDITCHANGE(IDC_STOP_BITS, OnChange)
	ON_CBN_SELCHANGE(IDC_STOP_BITS, OnChange)
	ON_CBN_EDITCHANGE(IDC_PARITY, OnChange)
	ON_CBN_SELCHANGE(IDC_PARITY, OnChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg message handlers

void COptionsDlg::OnOK() 
{
	Save_Changes();
	CDialog::OnOK();
}

void COptionsDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void COptionsDlg::OnApply() 
{
	Save_Changes();
}

void COptionsDlg::OnComDefaults() 
{
	m_Combo_Com.SetCurSel(D_COM);
	m_Combo_Baud.SetCurSel(D_BAUD);
	m_Combo_ByteSize.SetCurSel(D_BYTE);
	m_Combo_Parity.SetCurSel(D_PARITY);
	m_Combo_StopBits.SetCurSel(D_STOP);

	UpdateData(false);
	OnChange();
}

BOOL COptionsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	

	CSimApp* pApp = (CSimApp*)AfxGetApp();


	m_Combo_Com.SetCurSel(pApp->GetProfileInt("Config","COM",D_COM));
	m_Combo_Baud.SetCurSel(pApp->GetProfileInt("Config","Baud",D_BAUD));
	m_Combo_ByteSize.SetCurSel(pApp->GetProfileInt("Config","Byte Size",D_BYTE));
	m_Combo_Parity.SetCurSel(pApp->GetProfileInt("Config","Parity",D_PARITY));
	m_Combo_StopBits.SetCurSel(pApp->GetProfileInt("Config","Stop Bits",D_STOP));




	OnChange();

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptionsDlg::OnChange() 
{
	/* Compare Current with defaults */
	UpdateData(TRUE);

	if (m_Combo_Com.GetCurSel() == D_COM &&
		m_Combo_Baud.GetCurSel() == D_BAUD &&
		m_Combo_ByteSize.GetCurSel() == D_BYTE &&
		m_Combo_Parity.GetCurSel() == D_PARITY &&
		m_Combo_StopBits.GetCurSel() == D_STOP)
			GetDlgItem(IDC_COM_DEFAULTS)->EnableWindow(FALSE);
	else
			GetDlgItem(IDC_COM_DEFAULTS)->EnableWindow(TRUE);



	CheckforChanges();
}

void COptionsDlg::CheckforChanges()
{
	CSimApp* pApp = (CSimApp*)AfxGetApp();

	bool ch = false;
 
	UpdateData(TRUE);

	if (pApp->GetProfileInt("Config","COM",D_COM) != (unsigned)m_Combo_Com.GetCurSel()) ch = true;
	if (pApp->GetProfileInt("Config","Baud",D_BAUD) != (unsigned)m_Combo_Baud.GetCurSel()) ch = true;
	if (pApp->GetProfileInt("Config","Byte Size",D_BYTE) != (unsigned)m_Combo_ByteSize.GetCurSel()) ch = true;
	if (pApp->GetProfileInt("Config","Parity",D_PARITY) != (unsigned)m_Combo_Parity.GetCurSel()) ch = true;
	if (pApp->GetProfileInt("Config","Stop Bits",D_STOP) != (unsigned)m_Combo_StopBits.GetCurSel()) ch = true;

	if (ch == true)		GetDlgItem(IDC_APPLY)->EnableWindow(TRUE);
	else				GetDlgItem(IDC_APPLY)->EnableWindow(FALSE);

}

void COptionsDlg::Save_Changes()
{
	UpdateData(TRUE);
	CSimApp* pApp = (CSimApp*)AfxGetApp();
	pApp->WriteProfileInt("Config","COM",m_Combo_Com.GetCurSel());
	pApp->WriteProfileInt("Config","Baud",m_Combo_Baud.GetCurSel());
	pApp->WriteProfileInt("Config","Byte Size",m_Combo_ByteSize.GetCurSel());
	pApp->WriteProfileInt("Config","Parity",m_Combo_Parity.GetCurSel());
	pApp->WriteProfileInt("Config","Stop Bits",m_Combo_StopBits.GetCurSel());



	OnChange();
}
